#ifndef PRJ_CAMERA_H
#define PRJ_CAMERA_H

#include "Obj.h"
#include "String3d.h"

class Camera:public Obj{
public:
	Camera();
	void RotateTheta(double deg);
	void RotatePhi(double deg);
	void RotateRho(double deg);
	void RotateThetaMouse(double deg);
	void RotatePhiMouse(double deg);
	void RotateRhoMouse(double deg);
	void walk(double const& nb);
	void strafe(double const& nb);
	void jump(double const& nb);
	void init();
		
	void setFollow(Obj&);
	void setFollow();

	void ApplyLeftFrustum();
	void ApplyRightFrustum();
	void look();
	
	void focusMove(double const& var);
	void perspectiveMove(double const& var);
	void motionBlurMove(double const& var);
	double getMotionBlur();
	double getPerspective();
	double getFocus();
	int getCompassState();
	
	void dispRepere();
	void dispInterface();
	
	void update(double deltaT);
	
	double fast;
	int showBoussole;
	bool showTerminal;
	
	void setLeftPanel(string const&);
	void setRightPanel(string const&);
	void setTitle(string const&);

	void PanelBackground(int );

	void message(string const&,double timedisp = 1500);

	void setmAspectRatio(double nb);

private:
	int panelBackground;
	double messageTimeCount;
	string messagestr;
	string leftPanelstr;
	string rightPanelstr;
	string titlestr;

	Vect posLIGHT;
	Obj* follow;
	Vect w,s,q;
	double camSpeed;
	public:double theta;
	private:double dtheta;
	double ddtheta;
	public:double phi;
	private:double dphi;
	double ddphi;
	double rho;
	double drho;
	double ddrho;
	double thetaInterface;
	double phiInterface;
	double rhoInterface;
	double motionBlur;
	double dmotionBlur;
	//stereoCam
	double mConvergence;
	double dmConvergence;
	double mEyeSeparation;
	double mAspectRatio;
	double mFOV;
	double dmFOV;
	double mNearClippingDistance;
	double mFarClippingDistance;
};

#endif