#include "Force.h"

//---------GRAV---------
ObjG::ObjG(set<Obj*> & tabObj,Vect const& x,double const& mass,Vect const& dx, Vect const& ang, Vect const& mcin):
			  Obj(x,mass,dx,ang,mcin),tabGrav(&tabObj){}

void ObjG::force(){
	for(auto it : (*tabGrav)){
		Vect direction((getX()-(*it).getX()));
		if(direction.normeCarree()!=0)
		it->addFObjCoord(6.67300*pow(10,-11)* getM() /( direction||false) * it->getM() * direction.normalize());
	}//!verifier
}

//---------CHARG---------


double ObjC::getC() const{return c;}

void ObjC::setC(double const& charge){c=charge;}

ObjC::ObjC(set<ObjC*>& tabCharg,Vect const& x,double const& mass, double const& charg,
			  Vect const& dx, Vect const& ang, Vect const& mcin):
			  Obj(x,mass,dx,ang,mcin),
			  tabCharg(&tabCharg),c(charg){}

void ObjC::force(){
   for(auto it : (*tabCharg)){
		Vect direction=-(getX()-(*it).getX());
		if(direction.normeCarree()!=0)// division par 0 !
		(*it).elecField+=   direction.normalize()*getC()*pow(10,12)/( 4*PI*8.854* (direction||false) );//!!!!!
		(*it).magnetField+={0,0,0};//!!!!
	}
}

void ObjC::update(){
	addFObjCoord(getC()*getdx()^magnetField);//magnetisme
	addFObjCoord(getC()*elecField);//electric

	Obj::update();
}

void ObjC::init(){
	Obj::init();
	magnetField=Vect(3);
	elecField=Vect(3);

}

ostream& ObjC::cdisp(ostream& out){
	Obj::cdisp(out);
	out<<"Charg : "<<getC()<<endl;
	out<<"ElecF : "<<elecField;
	out<<"MagnF : "<<magnetField;
	return out;
}

//---------------------------------------
ObjCG::ObjCG(set<Obj*> & tabObj,set<ObjC*> & tabCharg,Vect const& x,double const& mass, double const& charg,
	Vect const& dx, Vect const& ang, Vect const& mcin):
	//Obj(x,mass,dx,ang,mcin),Charg(tabCharg,charg),Grav(tabObj){}
	Obj(x,mass,dx,ang,mcin),ObjC(tabCharg,x,mass,charg),ObjG(tabObj,x,mass){}

void ObjCG::force(){
	ObjC::force();
	ObjG::force();
}
