#ifndef PRJ_FORCE_H
#define PRJ_FORCE_H

#include "Obj.h"
#include <set>
#include "CouldBeInseredToSystem.h"

//using namespace std;

class Force:virtual public CouldBeInseredToSystem{
    public:
        virtual void force()=0;
};

//MAGNET
class Magnet:public Obj, public Force{
    protected:
        //! A CARACTERISER
    public:
        //!GET / SET
        virtual void force();
};


//GRAV
class ObjG:virtual public Obj, virtual public Force{
    protected:
        std::set<Obj*>* tabGrav;
    public:
        ObjG(std::set<Obj*> & tabObj,Vect const& x,double const& mass, Vect const& dx=Vect(3), Vect const& ang=Vect(3), Vect const& mcin=Vect(3));//!!!!!!!!
        virtual void force();
        Obj::init;
        Obj::cdisp;
        Obj::disp;
        Obj::supportPoint;
};


//CHARG
class ObjC:virtual public Obj, virtual public Force{//! PENSER A VIDER CHARGE ET ELEC FIELD A CHAQUE BOUCLE
    protected:
        std::set<ObjC*>* tabCharg;
        double c;//charge electrique
    public:
        Vect elecField;
        Vect magnetField;
        void setC(double const& charge);
        double getC() const;
        ObjC(std::set<ObjC*> & tabCharg, Vect const& x,double const& mass, double const& charg,
              Vect const& dx=Vect(3), Vect const& ang=Vect(3), Vect const& mcin=Vect(3));//!!!!!!
        virtual void force();
        virtual void update();//!!!
        virtual void init();
        Obj::disp;
        ostream& cdisp(ostream&);
        Obj::supportPoint;

};


//GRAV+CHARG
class ObjCG: public ObjC, public ObjG{
    public:
        ObjCG(std::set<Obj*> & tabObj,std::set<ObjC*> & tabC, Vect const& x,double const& mass, double const& charg,
              Vect const& dx=Vect(3), Vect const& ang=Vect(3), Vect const& mcin=Vect(3));
        virtual void force();
        ObjC::init;
        ObjC::update;
        ObjC::cdisp;
        Obj::disp;
        Obj::supportPoint;
};


#endif //PRJ_FORCE_H

