#ifndef PRJ_OBJ_H
#define PRJ_OBJ_H

#include "Vect.h"
#include "Matrix.h"
#include "Disp.h"
#include "Rand.h"
#include "CouldBeInseredToSystem.h"
#include "Integrator.h"
#include "String3d.h"


using namespace std;

class Obj: virtual  public Disp, virtual public CouldBeInseredToSystem{
	public:
		static Integrator* integ;
		bool forceTranslate;
		bool forceRotate;
		bool collision;
		bool showPath;
	protected:
		vector<Vect> path;
		void dispPath();

		Vect x;
		Vect dx;//dx/dt
		Vect f;//forces
		double m;//masse
		double temp;//temperature

		Matrix i;//inertie
		Vect ang;//angle : axe de rotation, norme=angle
		Vect mcin;//moment cin
		Vect mf;//moment force

	public:
		Vect getAcc();
		virtual double getVolume() const;
		virtual double getR() const;
		Matrix rotateMatrix(bool const& inverse=false);//changement de repre, sans translation

		Vect convertRefRel(Vect const& v);
		Vect convertRefAbs(Vect const& v);
		void enableTranslationForce(bool b=true);
		void enableRotationForce(bool b=true);

	//proprits
		void setM(double const& newM);
		void setT(double const& newT);
		double getT() const;
		double getM() const;

	//translations
		void addFWorldCoord(Vect const& df, Vect const& pos);
		void addFObjCoord(Vect const& df, Vect const& pos=Vect(3));
		void setF(Vect const& f);
		void setX(Vect const& v);
		void setdx(Vect const& v);
		Vect getX() const;
		Vect getdx() const;
		Vect getdxAbs(Vect const& pos) ;
		Vect getF() const;
	//rotations
		void addM(Vect const& df, Vect const& dfPos);//moment de force
		Vect getAng() const;
		Vect getVitAng() ;
		Vect getMCin() const;
		Vect getMf() const;
		void addMf(Vect const& m);
		void setAng(Vect const& v);
		void setMCin(Vect const& v);
		void setMf(Vect const& v);

		//collision
		virtual Vect supportPoint (Vect const& direction);

	//update
		virtual void init();
		virtual void update();

	//affichage
		virtual ostream& cdisp(ostream& out);
		virtual void disp(vector<bool> options);
	//CONSTR---
		Obj(Vect const& x,double const& mass,  Vect const& dx=Vect(3), Vect const& ang=Vect(3), Vect const& mcin=Vect(3));
		virtual ~Obj(){}
};

#endif //PRJ_OBJ_H
