#ifndef PRJ_OPENGLVIEW_H
#define PRJ_OPENGLVIEW_H

#include <stdlib.h>

#include "Universe.h"
#include "Camera.h"
//#include <wx/mediactrl.h>
//#include <wx/sound.h>
//#include "Sound.h"
#include <wx/mediactrl.h>
#include <wx/string.h>
#include <cstring>
#include <wx/utils.h>
#include <wx/defs.h>
//#include <wx/mousestate.h>
#include <wx/event.h>
//#include <AL>
#include "XmlParser.h"

#include <GL/freeglut.h>

class Fenetre;


class OpenGLView : public wxGLCanvas {
public:
	OpenGLView(Fenetre* parent, wxSize const& taille = wxDefaultSize, wxPoint const& position = wxDefaultPosition);
	virtual ~OpenGLView() {SetCursor( wxNullCursor );}

	void InitOpenGL();

protected:
	
	Fenetre* parent;
	void draw(wxPaintEvent& evenement);
	void OnSize(wxSizeEvent& evenement);
	void OnMouseButton(wxMouseEvent& event);
	void OnMouseMotion(wxMouseEvent& event);
	void OnKeyDown(wxKeyEvent& evenement);
	void OnKeyUp(wxKeyEvent& evenement);
	void OnEnterWindow(wxMouseEvent& evenement) { SetFocus(); }
	void OnTimer(wxTimerEvent& event);
	Camera cam;
	void cameraTerminal();

private:
	//Universe universe;
	bool infoPLUS;
	bool light;
	bool EPILEPTIK;
	bool dispInformation;
	bool dispFace;
	bool simulationOn;
	set<Obj*> superTabObj;//sera vide car rien en dehors de l'univers
	set<ObjC*> superTabCharg;//idem
	System mainSys;

	void choosePreset(int const& choice);
	
	vector<int> selectTool;
	
	bool mouseMod;
	bool stereoscopy;
	double compteurTimer;
	int xmouse;
	int ymouse;

	wxTimer* timer;// le "Timer"
	static int TIMER_ID;

DECLARE_EVENT_TABLE()
};



// ======================================================================
class Fenetre: public wxFrame {
public:
  Fenetre(wxString const& titre, wxSize const& taille = wxDefaultSize, wxPoint const& position = wxDefaultPosition, long style = wxDEFAULT_FRAME_STYLE);
  virtual ~Fenetre() {}
protected:
  void OnExit(wxCommandEvent& event) { Close(true); }
  OpenGLView* fogl;
DECLARE_EVENT_TABLE()
};







#endif
