
//#include <pulse/pulseaudio.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <SDL/SDL.h>
#include <iostream>

// source http://www.gnurou.org/writing/linuxmag/sdl/partie5

Uint8 * sounddata; // Les données du fichier son chargé 
Uint32 soundlength; // La taille du fichier son chargé, en octets 
Uint32 soundpos; // Position courante de lecture dans le fichier son 

void mixaudio(void * userdata, Uint8 * stream, int len){
	Uint32 tocopy = soundlength - soundpos > len ? len : soundlength - soundpos; // Attention à ne pas déborder lors de la copie 
	memcpy(stream, sounddata + soundpos, tocopy);    // Copie des données sonores dans le tampon audio... 
	soundpos += tocopy;   // Mise à jour de la position de lecture 
}

using namespace std;

int main(int argc, char *argv[]){
	SDL_AudioSpec desired, obtained, soundfile;
	SDL_AudioCVT cvt; 
	//system("pwd");
	if (SDL_Init(SDL_INIT_AUDIO) == -1) {cout<<"erreur init SDL AUDIO"<<endl;return 1;}

	if(argc==2)desired.freq = 44100;   // Son 16 bits stéréo à 44100 Hz 
	else desired.freq = 8000; 
	desired.format = AUDIO_U16SYS;
	desired.channels = 2;
	desired.samples = 512;
	desired.callback = &mixaudio;
	desired.userdata = NULL;

	if (SDL_OpenAudio(&desired, &obtained) != 0) {cout<<"erreur ouverture perif audio"<<endl;return 1;}
	if (SDL_LoadWAV(argv[1], &soundfile, &sounddata, &soundlength) == NULL) {cout<<"son pas charge (Avez vous pense a lancer ./unpack pour activer la musique ?)"<<endl;return 1;}
	//else{cout<<"OK"<<endl;}

	// Conversion vers le format du tampon audio 
	if (SDL_BuildAudioCVT(&cvt, soundfile.format, soundfile.channels, soundfile.freq, obtained.format, obtained.channels, obtained.freq) < 0) {cout<<"erreur convertisseur audio"<<endl;return 1;}

	// Création du tampon utilisé pour la conversion 
	cvt.buf = malloc(soundlength * cvt.len_mult);
	cvt.len = soundlength;
	memcpy(cvt.buf, sounddata, soundlength);

	if (SDL_ConvertAudio(&cvt) != 0) {cout<<"erreur"<<endl;return 1;}

	// Libération de l'ancien tampon, création du nouveau,
		//copie des données converties, effacement du tampon de conversion 
	SDL_FreeWAV(sounddata);
	sounddata = malloc(cvt.len_cvt);
	memcpy(sounddata, cvt.buf, cvt.len_cvt);
	free(cvt.buf);

	soundlength = cvt.len_cvt;
	//printf("Taille du son converti: %d octets\n", soundlength);
	soundpos = 0;

	SDL_PauseAudio(0);

	// On attend que l'autre thread ait fini la lecture du son... 
	while (soundpos < soundlength);
	SDL_PauseAudio(1);
	SDL_CloseAudio();

	SDL_Quit();
	return 0;
}
