#include "System.h"

void System::update(){
	//remettre les forces  0
	for(auto it:tabObj){
		it->init();
	}
	for(auto it : tabSys){
		it->init();
	}

	for(auto it :tabObstacle){
		it->init();
	}

	//force
	force();

	
	for(auto it :tabObj){
		(*it).update();
	}
	for(auto it :tabObstacle){
		it->update();
	}

	//! SI TROP LOIN, envoyer dans le parent, si pas de parent (parent = lui mme) => del
	
	//update sous Sys
	for(auto it : tabSys){
		(*it).update();
	}
}

void System::init(){
	acceleration=Vect(3);
	elecField=Vect(3);
	magnetField=Vect(3);
}

ObjCG* System::addObj(Vect const& pos, Vect const& vit,double mass, double const& size, bool const& grav, double const& charg,bool const& disp){
	ObjCG* ptr;
	if(mass==0)mass=1;
	if(size==0){
		ptr= new ObjCG(tabObj,tabCharg,pos,mass,charg,vit);
	}else{//size!=0
		ptr= new BallCG(tabObj,tabCharg,pos,mass,size,charg,vit);
	}
	tabObj.insert(ptr);
	if(disp)tabDisp.insert(ptr);
	if(grav || charg!=0) tabF.insert(ptr);//fera les deux si charg ou grav
	if(charg!=0) tabCharg.insert(ptr);
	return ptr;
}


Ball* System::addObjLife(Vect const& pos, Vect const& vit, double mass, double size,double life){
	BallLife* ptr;
	Ball* ptrRescue;
	if(mass==0)mass=1;
	try{
		ptrRescue= new BallLife(*this,life,pos,mass,size,vit);
	}
	catch(bad_alloc& ba){
		cout << "OMGWTFBBQ! WHAT HAPPEN ? SOMEBODY SET UP US THE BOMB ! MOVE ZIG." << endl;
		ptrRescue = new Ball(pos,size,mass,vit);
	}
	tabObj.insert(ptrRescue);
	tabDisp.insert(ptrRescue);
	return ptrRescue;
}

template< typename T >inline 
const std::type_info& get_type( const T& object ){
  return typeid(object) ;
}

void System::delObj(Obj* obj){
	for(auto it:tabObj){
		if( it == obj ){
			tabObj.erase( obj );
			break;//il n'y a pas 2 fois le mme obj dans le tab
		}
	}

	for(auto it:tabDisp ){
		if((Disp*)it==(Disp*)obj){
			tabDisp.erase((Disp*)obj);
			break;
		}
	}
	
	for(auto it:tabF){
		if((Force*)it==(Force*)obj){
			tabF.erase((Force*)obj);
			break;
		}
	}

	for(auto it:tabCharg){
		/*if((CouldBeInseredToSystem*)it==(CouldBeInseredToSystem*)obj){
			if(get_type(*obj)==get_type(*it)){//dsol
				ObjC* ptr = &(*obj);
				tabCharg.erase( ptr );
			}
			break;
		}*/
			//il y a ici un problme d  l'arbre : on ne peut pas enlever les charges lectriques du systme
			//car un Objet n'est pas forcment charg electriquement, le caste ne fonctionne pas

	}
}

Disp* System::addDisp(Disp* d){
	tabDisp.insert(d);
	return d;
}

System* System::addSys(Vect const& pos, double const& scale){
	System* ptr = new System(scale,tabObj,tabCharg,pos);
	tabSys.insert(ptr);
	return ptr;
}

Obj* System::generatePendulum(Vect const& pos, double const& length, double const& mass, double const& ballsize){
	ObjCG* pt(addObj(pos+Vect({length}),Vect(3),1,0));
	(*pt).enableTranslationForce(false);
	Obj* pt2(addObj(pos,Vect(3), mass, ballsize, false, 0,true));
	((Spring*)(addSpring(*pt2,(*pt),500,length)))->amorti=false;
	return pt2;
};

vector<Obj*> System::generatePendulum2(Vect const& pos, double const& length, double const& mass, double const& ballsize){
	vector<Obj*> tabObjOUT;
	double dotCOUNT=10;
	double space=length/dotCOUNT;
	double K=25;

	tabObjOUT= generate(pos,Vect{dotCOUNT,1,1},space,mass/2,0,K,false,0,true,true);
	tabObjOUT.push_back(addObj(pos+Vect({0,0,0}),Vect(3), mass, ballsize, false, 0,true));

	(*tabObjOUT[dotCOUNT-1]).enableTranslationForce(false);
	
	//addSpring(*tabObjOUT[tabObjOUT.size()-1],*tabObjOUT[0],25,0,true);
	// V V V renplacer la ligne de dessus : point attache rigolo
	addSpringAttach(*tabObjOUT[tabObjOUT.size()-1],*tabObjOUT[0],Vect({0,0,ballsize}),Vect(3),25,ballsize,true);

	return tabObjOUT;
};

vector<Obj*> System::generatePendulum3(Vect const& pos, double const& length, double const& mass, double const& ballsize){
	vector<Obj*> tabObjOUT;
	double dotCOUNT=10;
	double space=length/dotCOUNT;
	double K=25;

	tabObjOUT= generate(pos,Vect{dotCOUNT,2,2},space,50,0,K,false,0,false,true);
	tabObjOUT.push_back(addObj(pos+Vect({0,space/2,space/2}),Vect(3), mass, ballsize, false, 0,true));

	(*tabObjOUT[dotCOUNT-1]).enableTranslationForce(false);
	(*tabObjOUT[dotCOUNT+dotCOUNT-1]).enableTranslationForce(false);
	addSpring(*tabObjOUT[tabObjOUT.size()-1],*tabObjOUT[0],25,sqrt(3)*space/2,true);

	//(*tabObjOUT[0+0]).enableTranslationForce(false);
	//(*tabObjOUT[iCOUNT-1+0]).enableTranslationForce(false);
	//(*tabObjOUT[0+(jCOUNT-1)*iCOUNT]).enableTranslationForce(false);
	//(*tabObjOUT[iCOUNT-1+(jCOUNT-1)*iCOUNT]).enableTranslationForce(false);
	return tabObjOUT;
};

vector<Obj*> System::generate(Vect const& pos,Vect const& dim,double const& space,double const& mass,int const& meshtype,double const& K,bool const& breakable,double const& charg,bool const& dispBall,bool const& amorti, Vect const& vit){
	vector<Obj*> tabObjOUT;//! ne pas ajouter manuellement, sert juste temporairement pour la numerotation

	int objCOUNT(1);
	for(size_t i=0;i<dim.getDim();i++){objCOUNT*=(int)(dim.get(i));}
	int	iCOUNT=dim.get(0);if(iCOUNT==0)iCOUNT=1;
	int	jCOUNT=dim.get(1);if(jCOUNT==0)jCOUNT=1;
	int	kCOUNT=dim.get(2);if(kCOUNT==0)kCOUNT=1;

	double breakDeform(0),k2(0),l1(0),fmax(0);
	if(breakable){breakDeform=2;k2=10;l1=.2;fmax=10;}

	double const ballsize=0;//space/2;
	switch(meshtype){
		case 0:
			for(int k=0;k<kCOUNT;k++){
				for(int j=0;j<jCOUNT;j++){
					for(int i=0;i<iCOUNT;i++){
						tabObjOUT.push_back(addObj(pos+Vect({i*space,j*space,k*space}), vit,mass/objCOUNT, ballsize, false, charg,dispBall));
					}
				}
			}
			for(int k=0;k<kCOUNT;k++){
				for(int j=0;j<jCOUNT;j++){
					for(int i=0;i<iCOUNT;i++){
						if(i>0)addSpring(*tabObjOUT[i+j*iCOUNT+k*jCOUNT*iCOUNT],*tabObjOUT[(i-1)+j*iCOUNT+k*jCOUNT*iCOUNT],K,space,amorti							,breakDeform,k2,l1,fmax);
						if(i>0&&j>0)addSpring(*tabObjOUT[i+j*iCOUNT+k*jCOUNT*iCOUNT],*tabObjOUT[(i-1)+(j-1)*iCOUNT+k*jCOUNT*iCOUNT],K,sqrt(2)*space		,false,breakDeform,k2,l1,fmax);
						if(i>0&&k>0)addSpring(*tabObjOUT[i+j*iCOUNT+k*jCOUNT*iCOUNT],*tabObjOUT[(i-1)+j*iCOUNT+(k-1)*jCOUNT*iCOUNT],K,sqrt(2)*space		,false,breakDeform,k2,l1,fmax);
						if(i>0&&j>0&&k>0)addSpring(*tabObjOUT[i+j*iCOUNT+k*jCOUNT*iCOUNT],*tabObjOUT[(i-1)+(j-1)*iCOUNT+(k-1)*jCOUNT*iCOUNT],K,sqrt(3)*space	,false,breakDeform,k2,l1,fmax);
						if(j>0)addSpring(*tabObjOUT[i+j*iCOUNT+k*jCOUNT*iCOUNT],*tabObjOUT[i+(j-1)*iCOUNT+k*jCOUNT*iCOUNT],K,space,amorti							,breakDeform,k2,l1,fmax);
						if(k>0)addSpring(*tabObjOUT[i+j*iCOUNT+k*jCOUNT*iCOUNT],*tabObjOUT[i+j*iCOUNT+(k-1)*jCOUNT*iCOUNT],K,space,amorti							,breakDeform,k2,l1,fmax);
						if(j>0&&k>0)addSpring(*tabObjOUT[i+j*iCOUNT+k*jCOUNT*iCOUNT],*tabObjOUT[i+(j-1)*iCOUNT+(k-1)*jCOUNT*iCOUNT],K,sqrt(2)*space		,false,breakDeform,k2,l1,fmax);
					}
				}
			}

			//---FUN
			/*
			for(size_t i=0;i<tabObjOUT.size();i++){
				(*tabObjOUT[i]).setT(0.002);
			}*/
			//(*tabObjOUT[iCOUNT/2+(iCOUNT*jCOUNT)/2+(iCOUNT*(jCOUNT)*(int)(dim.get(2))-1)/2]).setdx(Vect({-0,-0,-20}));
			//(*tabObjOUT[iCOUNT-1+(iCOUNT*jCOUNT)/2]).setdx(Vect({-0,-0,-20}));
			//(*tabObjOUT[iCOUNT-1+(iCOUNT*jCOUNT)/2]).enableTranslationForce(false);
			/*for(size_t j=0;j<jCOUNT;j++){
				(*tabObjOUT[iCOUNT-1+j*iCOUNT]).enableTranslationForce(false);
			}for(size_t j=0;j<jCOUNT;j++){
				(*tabObjOUT[0+j*iCOUNT]).enableTranslationForce(false);
			}for(size_t i=0;i<iCOUNT;i++){
				(*tabObjOUT[i+(jCOUNT-1)*iCOUNT]).enableTranslationForce(false);
			}for(size_t i=0;i<iCOUNT;i++){
				(*tabObjOUT[i+0]).enableTranslationForce(false);
			}*/
			//(*tabObjOUT[0+0]).enableTranslationForce(false);
			//(*tabObjOUT[iCOUNT-1+0]).enableTranslationForce(false);
			//(*tabObjOUT[0+(jCOUNT-1)*iCOUNT]).enableTranslationForce(false);
			//(*tabObjOUT[iCOUNT-1+(jCOUNT-1)*iCOUNT]).enableTranslationForce(false);
			
			//---
			return tabObjOUT;

		case 1:
			for(int k=0;k<kCOUNT;k++){
				for(int j=0;j<jCOUNT;j++){
					for(int i=0;i<iCOUNT;i++){
						tabObjOUT.push_back(addObj(pos+Vect({i*space,j*space,k*space}), vit,mass/objCOUNT, ballsize, false, charg,dispBall));
					}
				}
			}
			for(int k=0;k<kCOUNT;k++){
				for(int j=0;j<jCOUNT;j++){
					for(int i=0;i<iCOUNT;i++){
						if(i>0)addSpring(*tabObjOUT[i+j*iCOUNT+k*jCOUNT*iCOUNT],*tabObjOUT[(i-1)+j*iCOUNT+k*jCOUNT*iCOUNT],K,space,amorti);
						if(i>0&&j>0)addSpring(*tabObjOUT[i+j*iCOUNT+k*jCOUNT*iCOUNT],*tabObjOUT[(i-1)+(j-1)*iCOUNT+k*jCOUNT*iCOUNT],K,space);
						if(i>0&&k>0)addSpring(*tabObjOUT[i+j*iCOUNT+k*jCOUNT*iCOUNT],*tabObjOUT[(i-1)+j*iCOUNT+(k-1)*jCOUNT*iCOUNT],K,space);
						if(i>0&&j>0&&k>0)addSpring(*tabObjOUT[i+j*iCOUNT+k*jCOUNT*iCOUNT],*tabObjOUT[(i-1)+(j-1)*iCOUNT+(k-1)*jCOUNT*iCOUNT],K,space);
						if(j>0)addSpring(*tabObjOUT[i+j*iCOUNT+k*jCOUNT*iCOUNT],*tabObjOUT[i+(j-1)*iCOUNT+k*jCOUNT*iCOUNT],K,space,amorti);
						if(k>0)addSpring(*tabObjOUT[i+j*iCOUNT+k*jCOUNT*iCOUNT],*tabObjOUT[i+j*iCOUNT+(k-1)*jCOUNT*iCOUNT],K,space,amorti);
						if(j>0&&k>0)addSpring(*tabObjOUT[i+j*iCOUNT+k*jCOUNT*iCOUNT],*tabObjOUT[i+(j-1)*iCOUNT+(k-1)*jCOUNT*iCOUNT],K,space);
					}
				}
			}
			return tabObjOUT;

		case 2:
			for(size_t k=0;k<kCOUNT;k++){
				for(size_t j=0;j<jCOUNT;j++){
					for(size_t i=0;i<iCOUNT;i++){
						tabObjOUT.push_back(addObj(pos+Vect({i*space,j*space,k*space}),vit, mass/objCOUNT, ballsize, false, charg,dispBall));
					}
				}
			}
			/*for(int i=0;i<iCOUNT;i++){
				for(int j=0;j<jCOUNT;j++){
					if(i>0)addSpring(*tabObjOUT[i+j*iCOUNT],*tabObjOUT[(i-1)+(j)*iCOUNT],K,space);
					if(j>0)addSpring(*tabObjOUT[i+j*iCOUNT],*tabObjOUT[i+(j-1)*iCOUNT],K,space);
					if(i>0&&j>0){
						if((i+j)%2==0)addSpring(*tabObjOUT[i+j*iCOUNT],*tabObjOUT[(i-1)+(j-1)*iCOUNT],K,sqrt(2)*space);
						else addSpring(*tabObjOUT[(i-1)+j*iCOUNT],*tabObjOUT[i+(j-1)*iCOUNT],K,sqrt(2)*space);
					}
				}
			}*/
			for(int k=0;k<kCOUNT;k++){
				for(int j=0;j<jCOUNT;j++){
					for(int i=0;i<iCOUNT;i++){
						if(i>0)addSpring(*tabObjOUT[i+j*iCOUNT+k*jCOUNT*iCOUNT],*tabObjOUT[(i-1)+j*iCOUNT+k*jCOUNT*iCOUNT],K,space,amorti);
						if(j>0)addSpring(*tabObjOUT[i+j*iCOUNT+k*jCOUNT*iCOUNT],*tabObjOUT[i+(j-1)*iCOUNT+k*jCOUNT*iCOUNT],K,space,amorti);
						if(k>0)addSpring(*tabObjOUT[i+j*iCOUNT+k*jCOUNT*iCOUNT],*tabObjOUT[i+j*iCOUNT+(k-1)*jCOUNT*iCOUNT],K,space,amorti);
						
						if(i>0&&j>0){
							if((i+j)%2==0)addSpring(*tabObjOUT[i+j*iCOUNT+k*jCOUNT*iCOUNT],*tabObjOUT[(i-1)+(j-1)*iCOUNT+k*jCOUNT*iCOUNT],K,sqrt(2)*space,false,breakDeform,k2,l1,fmax);
							else addSpring(*tabObjOUT[i+(j-1)*iCOUNT+k*jCOUNT*iCOUNT],*tabObjOUT[(i-1)+(j)*iCOUNT+k*jCOUNT*iCOUNT],K,sqrt(2)*space			,false,breakDeform,k2,l1,fmax);
						}
						if(i>0&&k>0){
							if((i+k)%2==0)addSpring(*tabObjOUT[i+j*iCOUNT+k*jCOUNT*iCOUNT],*tabObjOUT[(i-1)+j*iCOUNT+(k-1)*jCOUNT*iCOUNT],K,sqrt(2)*space,false,breakDeform,k2,l1,fmax);
							else addSpring(*tabObjOUT[i+j*iCOUNT+(k-1)*jCOUNT*iCOUNT],*tabObjOUT[(i-1)+j*iCOUNT+(k)*jCOUNT*iCOUNT],K,sqrt(2)*space,				false,breakDeform,k2,l1,fmax);
						}
						if(j>0&&k>0){
							if((j+k)%2==0)addSpring(*tabObjOUT[i+j*iCOUNT+k*jCOUNT*iCOUNT],*tabObjOUT[i+(j-1)*iCOUNT+(k-1)*jCOUNT*iCOUNT],K,sqrt(2)*space,false,breakDeform,k2,l1,fmax);
							else addSpring(*tabObjOUT[i+j*iCOUNT+(k-1)*jCOUNT*iCOUNT],*tabObjOUT[i+(j-1)*iCOUNT+(k)*jCOUNT*iCOUNT],K,sqrt(2)*space				,false,breakDeform,k2,l1,fmax);
						}
						//if(i>0&&j>0&&k>0)addSpring(*tabObjOUT[i+j*iCOUNT+k*jCOUNT*iCOUNT],*tabObjOUT[(i-1)+(j-1)*iCOUNT+(k-1)*jCOUNT*iCOUNT],K,space);
					}
				}
			}
			return tabObjOUT;

		case 3:
		case 4://solides  comportement spciaux, autre mesh//sphere ovale etc...//cylindre//trucs zarb  voir
		break;
	}//*/
}

Force* System::addSpringAttach(Obj& o1,Obj& o2,Vect const& attache1,Vect const& attache2,double const& k1,double const& l0,bool const& amorti){
	Spring* ptr(new Spring(o1,o2,k1,l0,attache1,attache2));
	tabF.insert(ptr);
	tabDisp.insert((Disp*)ptr);
	if(amorti)ptr->amorti=true;
	return ptr;
}


Force* System::addSpring(Obj& o1,Obj& o2,double const& k1,double const& l0,bool const& amorti,int const& breakDeform,double const& k2, double const& l1, double const& fmax){
	Spring* ptr;
	switch(breakDeform){
		case 0://not deform not break
			ptr= new Spring(o1,o2,k1,l0);
			break;
		case 1://deform
			ptr= new SpringDeform((*this),o1,o2,k1,k2,l0,l1,fmax);
			break;
		case 2://break
			ptr= new SpringBreak((*this),o1,o2,k1,l0,fmax);
			break;
	}
	tabF.insert(ptr);
	tabDisp.insert((Disp*)ptr);
	if(amorti)ptr->amorti=true;
	return ptr;
}

void System::delF(Force* f){// pour les ressorts cassables
	Disp* ptr=(Disp*)f;
	tabDisp.erase(ptr);
	tabF.erase(f);
	//cout<<"spring breaked"<<endl;
	//delete f;
}

/*void System::addF(Vect const& df, Vect const& pos){
	(*this).acceleration=df;
}*/


Ventillateur* System::addVentillateur(Vect const& pos,double forceStrength, double mass,double rayon){
	Ventillateur* ptr = new Ventillateur(tabObj,pos,mass,rayon,forceStrength);
	tabObj.insert((Obj*)ptr);
	tabDisp.insert((Disp*)ptr);
	tabF.insert((Force*)ptr);
	return ptr;
}
Obstacle* System::addObstacle(Vect const& pos, Vect const& dim, double mass, Vect const& ang){
	Obstacle* ptr = new Obstacle(tabObj,pos,dim,mass,ang);
	tabDisp.insert((Disp*)ptr);
	tabF.insert((Force*)ptr);
	tabObstacle.insert(ptr);
	return ptr;
}

Collision* System::getCollision(){return &collision;}

void System::collisionSound(bool b){
	collisionSoundBoolean=b;
}

Archimed* System::getArchimed(){return &archimed;}

void System::force(){
	//propre au Systme
		//force magnetique + elec sur objC + Systeme
		for(auto it:tabCharg){
			(*it).magnetField+=magnetField;//q*VxB
			(*it).elecField+=elecField;//q*1/(4*pi*e)/r^2
		}
		for(auto it : tabSys){
			(*it).magnetField+=magnetField;
			(*it).elecField+=elecField;
		}

		//force grav sur Obj + Systeme
		for(auto it :tabObj){
			(*it).addFObjCoord(acceleration*(*it).getM());
		}
		for(auto it :tabSys){
			(*it).acceleration+=acceleration;//! + acceleration si systme en mouvement (*tabSys[i]).acceleration+=;
		}

		if(collisionBool){
			collision.force();
		}

		/*//les objets grav sur les systmes
		for (auto it :tabSys){
			for(set<Obj*>::iterator jt;jt!=tabObj.end();jt++){
				//! (*tabSys[i]).getX()-(*tabObj[j]).getX()
				//COMPLETER COMPLETER
				//COMPLETER COMPLETER
				//COMPLETER COMPLETER
				//COMPLETER COMPLETER
				//COMPLETER COMPLETER
			}
		}*////////////////////////////////////////////////////////////////////

	//les Forces dans le systme
		for(auto it :tabF){
			(*it).force();
		}

		if(archimedBool)archimed.force();
		
	//frottement
		for(auto it :tabObj){
			it->addFObjCoord(-frottement*(*it).getdx());
			it->addMf(-frottement*it->getMCin());
		}
}

void System::disp(vector<bool> options){
	
	glTranslated(getX().get(0),getX().get(1),getX().get(2));
	//glScaled(scale,scale,scale); //////////////////////////////////////////////// BUG A CORRIGER
	for(auto it :tabDisp){
		(*(it)).disp(options);
	}
	for(auto it :tabSys){
		(*(it)).disp(options);
	}
}

ostream& System::cdisp(ostream& out){
	out<<"SYSTEM ---"<<endl;
	for(auto it:tabDisp){
		(*it).cdisp(out);
	}
	out<<"--------"<<endl<<endl;
	return out;
}

System::System(int const& scale,set<Obj*> & tabOb,set<ObjC*> & tabC,Vect const& pos, Vect const& ang,bool const& collision):Obj(pos,0),ObjCG(tabOb, tabC,pos,0,0),scale(scale),collision(tabObj,collisionTable),archimed(tabObj,1.2),collisionBool(false),frottement(0){
	if(collisionBool) {
		cout<<"collision ON"<<endl;
	}
}

void System::clear(){
	set<CouldBeInseredToSystem*> DELETOR;

	for(auto it:tabObj){
		if(DELETOR.find(it)==DELETOR.end()) DELETOR.insert(it);
		//else cout<<"cet objet est deja qq part"<<endl;
	}
	for(auto it:tabObstacle){
		if(DELETOR.find(it)==DELETOR.end()) DELETOR.insert(it);
		//else cout<<"cet objet est deja qq part"<<endl;
	}
	for(auto it:tabF){
		if(DELETOR.find(it)==DELETOR.end()) DELETOR.insert(it);
		//else cout<<"cette force est deja qq part"<<endl;
	}
	for(auto it :tabSys){
		//if(DELETOR.find(it)==DELETOR.end()) DELETOR.insert(it);
		if(DELETOR.find(it)==DELETOR.end()) DELETOR.insert(it);
		//else cout<<"ce Systeme est deja qq part"<<endl;
	}

	for(auto it :DELETOR){
		delete it;
	}

	tabObj	=	*(new set<Obj*>);
	tabObstacle=*(new set<Obstacle*>);
	tabF		=	*(new set<Force*>);
	tabSys	=	*(new set<System*>);
	tabDisp	=	*(new set<Disp*>);
	tabCharg=	*(new set<ObjC*>);
	//cout<<"------------------"<<endl;
}

System::~System(){
	clear();
}
