#include "XmlParser.h"

vector<Operation> ParseurXml(string nom_fichier){
	ifstream entree;
	vector<Operation> stock;
	entree.open(nom_fichier);

	if(entree.fail()) {
		cerr << "Erreur : impossible de lire le fichier" << nom_fichier << endl;
	}
	else {
		string mot;
		while(entree >> mot){
			if(mot == "<") {
				entree>>mot;
				if(mot == "addObj" || mot == "addSpring" || mot == "generate" || mot == "addObstacle" || mot == "addSpringAttach" || mot == "addSys" || mot == "generatePendulum" || mot == "generatePendulum2" || mot == "generatePendulum3" || mot == "addVentillateur" || mot == "setCollision"/* || mot == "addDisp"*/){
					Operation op;
					op.nomOp=mot;
					while(entree>>mot){
						if(mot == "collision"){
							int nb;
							entree>>nb;
							op.collision=nb;
						}
						if(mot == "size"){
							double nb;
							entree>>nb;
							op.size=nb;
						}
						else if(mot == "charge"){
							double nb;
							entree>>nb;
							op.charge=nb;
						}
						else if(mot == "masse"){
							double nb;
							entree>>nb;
							op.masse=nb;
						}
						else if(mot == "k1"){
							double nb;
							entree>>nb;
							op.k1=nb;
						}
						else if(mot == "k2"){
							double nb;
							entree>>nb;
							op.k2=nb;
						}
						else if(mot == "l0"){
							double nb;
							entree>>nb;
							op.l0=nb;
						}
						else if(mot == "l1"){
							double nb;
							entree>>nb;
							op.l1=nb;
						}
						else if(mot == "fmax"){
							double nb;
							entree>>nb;
							op.fmax=nb;
						}
						else if(mot == "scale"){
							double nb;
							entree>>nb;
							op.scale=nb;
						}
						else if(mot == "space"){
							double nb;
							entree>>nb;
							op.space=nb;
						}
						else if(mot == "K"){
							double nb;
							entree>>nb;
							op.K=nb;
						}
						else if(mot == "longueur"){
							double nb;
							entree>>nb;
							op.longueur=nb;
						}
						else if(mot == "rayon"){
							double nb;
							entree>>nb;
							op.rayon=nb;
						}
						else if(mot == "forceStrength"){
							double nb;
							entree>>nb;
							op.forceStrength=nb;
						}
						else if(mot == "position"){
							double nb;
							entree>>nb;
							op.position.addDim(nb);
							entree>>nb;
							op.position.addDim(nb);
							entree>>nb;
							op.position.addDim(nb);
						}
						else if(mot == "dimension"){
							double nb;
							entree>>nb;
							op.dimension.addDim(nb);
							entree>>nb;
							op.dimension.addDim(nb);
							entree>>nb;
							op.dimension.addDim(nb);
						}
						else if(mot == "angle"){
							double nb;
							entree>>nb;
							op.angle.addDim(nb);
							entree>>nb;
							op.angle.addDim(nb);
							entree>>nb;
							op.angle.addDim(nb);
						}
						else if(mot == "vitesse"){
							double nb;
							entree>>nb;
							op.vitesse.addDim(nb);
							entree>>nb;
							op.vitesse.addDim(nb);
							entree>>nb;
							op.vitesse.addDim(nb);
						}
						else if(mot == "attache1"){
							double nb;
							entree>>nb;
							op.attache1.addDim(nb);
							entree>>nb;
							op.attache1.addDim(nb);
							entree>>nb;
							op.attache1.addDim(nb);
						}
						else if(mot == "attache2"){
							double nb;
							entree>>nb;
							op.attache2.addDim(nb);
							entree>>nb;
							op.attache2.addDim(nb);
							entree>>nb;
							op.attache2.addDim(nb);
						}
						else if(mot == "gravite"){
							int oui;
							entree>>oui;
							op.gravite=oui;
						}
						else if(mot == "display"){
							int oui;
							entree>>oui;
							op.display=oui;
						}
						else if(mot == "amorti"){
							int oui;
							entree>>oui;
							op.amorti=oui;
						}
						else if(mot == "breakable"){
							int oui;
							entree>>oui;
							op.breakable=oui;
						}
						else if(mot == "dispBall"){
							int oui;
							entree>>oui;
							op.dispBall=oui;
						}
						else if(mot == "breakDeform"){
							int nb;
							entree>>nb;
							op.breakDeform=nb;
						}
						else if(mot == "meshType"){
							int nb;
							entree>>nb;
							op.meshType=nb;
						}
						else if(mot == "ID"){
							int nb;
							entree>>nb;
							op.ID=nb;
						}
						else if(mot == "ID1"){
							int nb;
							entree>>nb;
							op.ID1=nb;
						}
						else if(mot == "ID2"){
							int nb;
							entree>>nb;
							op.ID2=nb;
						}

						else if(mot== ">") break;
					}
					stock.push_back(op);
				}
			}
		}
	}
	return stock;
}



void load(System& sys, string const& path){
	vector<Operation> tabOp = ParseurXml(path);
	map <int,Obj*> tableObjID;

	for (int i=0; i<tabOp.size();i++){
		if(tabOp[i].nomOp=="setCollision"){
			if(tabOp[i].collision)sys.collisionBool=true;
			else sys.collisionBool=false;
		}
		if(tabOp[i].nomOp=="addObj"){
			Obj* ptr;
			ptr=sys.addObj(tabOp[i].position, tabOp[i].vitesse, tabOp[i].masse, tabOp[i].size, tabOp[i].gravite, tabOp[i].charge, tabOp[i].display);
			tableObjID.insert( pair<int,Obj*>(tabOp[i].ID , ptr));
		}
		else if(tabOp[i].nomOp=="addSpring"){
			Obj* ptr1=tableObjID[tabOp[i].ID1];//transformer le ID en pointeur
			Obj* ptr2=tableObjID[tabOp[i].ID2];//transformer le ID en pointeur
			sys.addSpring(*ptr1, *ptr2, tabOp[i].k1, tabOp[i].l0, tabOp[i].amorti, tabOp[i].breakDeform, tabOp[i].k2, tabOp[i].l1, tabOp[i].fmax);
		}
		else if(tabOp[i].nomOp=="generate"){
			sys.generate(tabOp[i].position, tabOp[i].dimension, tabOp[i].space, tabOp[i].masse, tabOp[i].meshType, tabOp[i].K, tabOp[i].breakable, tabOp[i].charge, tabOp[i].dispBall, tabOp[i].amorti, tabOp[i].vitesse);
		}
		else if(tabOp[i].nomOp=="addObstacle"){
			sys.addObstacle(tabOp[i].position, tabOp[i].dimension, tabOp[i].masse, tabOp[i].angle);
			//
			//
		}
		else if(tabOp[i].nomOp=="addSpringAttach"){
			Obj* ptr1=tableObjID[tabOp[i].ID1];//transformer le ID en pointeur
			Obj* ptr2=tableObjID[tabOp[i].ID2];//transformer le ID en pointeur
			sys.addSpringAttach(*ptr1, *ptr2, tabOp[i].attache1, tabOp[i].attache2, tabOp[i].k1, tabOp[i].l0, tabOp[i].amorti);
		}
		else if(tabOp[i].nomOp=="addSys"){
			sys.addSys(tabOp[i].position, tabOp[i].scale);
		}
		else if(tabOp[i].nomOp=="generatePendulum"){
			sys.generatePendulum(tabOp[i].position, tabOp[i].longueur, tabOp[i].masse, tabOp[i].rayon);
		}
		else if(tabOp[i].nomOp=="generatePendulum2"){
			sys.generatePendulum2(tabOp[i].position, tabOp[i].longueur, tabOp[i].masse, tabOp[i].rayon);
		}
		else if(tabOp[i].nomOp=="generatePendulum3"){
			sys.generatePendulum3(tabOp[i].position, tabOp[i].longueur, tabOp[i].masse, tabOp[i].rayon);
		}
		else if(tabOp[i].nomOp=="addVentillateur"){
			sys.addVentillateur(tabOp[i].position, tabOp[i].forceStrength, tabOp[i].masse, tabOp[i].rayon);
			//
			//
		}
	}
}