#ifndef PRJ_ALLOBJ_H
#define PRJ_ALLOBJ_H

#include "AllObj.h"

ObjG::ObjG(vector<Obj*> & tabObj,Vect const& x,double const& mass,Vect const& dx, Vect const& ang, Vect const& mcin):
              Obj(x,mass,dx,ang,mcin),Grav(tabObj){}

void ObjG::force(){
    for(size_t i=0;i<(*tabGrav).size();i++){
        (*(*tabGrav)[i]).addF( 6.67300*pow(10,-11) * (getM()*(*(*tabGrav)[i]).getM())/( ((*(*tabGrav)[i]).getX()-getX())||false) * ((*(*tabGrav)[i]).getX()-getX()).normalize() );
    }//!verifier
}

ObjC::ObjC(vector<ObjC*>& tabCharg,Vect const& x,double const& mass, double const& charg,
              Vect const& dx, Vect const& ang, Vect const& mcin):
              Obj(x,mass,dx,ang,mcin),
              Charg(tabCharg,charg){}

void ObjC::force(){
   for(size_t i=0;i<(*tabCharg).size();i++){
        (*(*tabCharg)[i]).elecField+={0,0,0};//!!!!
        (*(*tabCharg)[i]).magnetField+=1/(4*3.14*8.854*pow(10,-12))/
                                    ((*(*tabCharg)[i]).getX()-getX())||false
                                    *getC()*
                                    ((*(*tabCharg)[i]).getX()-getX()).normalize();//!!!!!
    }
}

void ObjC::update(){
    addF(getC()*getdx()^magnetField);//magnetisme
    addF(getC()*elecField);//electric

    Obj::update();
};


ObjCG::ObjCG(vector<Obj*> & tabObj,vector<ObjC*> & tabCharg,Vect const& x,double const& mass, double const& charg,
    Vect const& dx, Vect const& ang, Vect const& mcin):
    //Obj(x,mass,dx,ang,mcin),Charg(tabCharg,charg),Grav(tabObj){}
    Obj(x,mass,dx,ang,mcin),ObjC(tabCharg,x,mass,charg),ObjG(tabObj,x,mass){}

void ObjCG::force(){
    Charg::force();
    Grav::force();
}

#endif
